part of '../object_reference.dart';

/// A [Ref] to an [Object] of type [T], of which you
/// cannot modify the value.
class ConstRef<T> extends Ref<T> {
  ConstRef(T value) : super(value);

  ConstRef.fromRef(Ref<T> ref) : super._internal(ref._ref);

  @override
  set value(T value) => throw StateError("Setting the value of "
      "a ConstRef is not allowed!");
}
