part of '../object_reference.dart';

extension RefExtension on Object {
  /// Get a [MutableRef] of the [Object] this method was called on.
  ///
  /// If `this` is a [Ref], then `this` as a [MutableRef]
  /// gets returned.
  MutableRef<T> ref<T>() => (this is Ref<T>)
      ? MutableRef<T>.fromRef(this as Ref<T>)
      : MutableRef(this as T);

  /// Get a [ConstRef] of the [Object] this method was called on.
  ///
  /// If `this` is a [Ref], then `this` as a [ConstRef]
  /// gets returned.
  ConstRef<T> constRef<T>() => (this is Ref<T>)
      ? ConstRef<T>.fromRef(this as Ref<T>)
      : ConstRef(this as T);
}
